#include "common.h"
#include "keyboard.h"

int
mm_keyb_pressed (int scancode)
{
  int counter;
  if (scancode != KEYB_ANYKEY)
    return (keytab[scancode]);
  else
    for (counter = 1; counter < 127; counter++)
      if (keytab[counter])
	return (1);
  return (0);
}

void
mm_keyb_update (void)
{
  ggi_event event;
  ggi_event_mask mask;
  struct timeval t = { 0, 0 };

  while ((mask = ggiEventPoll (vis, emKey, &t))) {
    ggiEventRead (vis, &event, emKey);
    if (event.any.type == evKeyPress)
      keytab[event.key.button] = 1;
    else if (event.any.type == evKeyRelease)
      keytab[event.key.button] = 0;
  }
}
