#include "../../manic.h"
#include "common.h"

void
mm_snd_init (void)
{
  MikMod_RegisterAllDrivers ();
  MikMod_RegisterAllLoaders ();
  md_mode |= DMODE_SOFT_MUSIC;
  if (MikMod_Init ("")) {
    fprintf (stderr, "Could not initialize sound!\n");
    exit (2);
  }
  if (!(manicmod = Player_Load (MUSIC_MOD, 64, 0))) {
    fprintf (stderr, "Could not load %s!\n", MUSIC_MOD);
    MikMod_Exit ();
    exit (2);
  }
  if (!(jump = Sample_Load (JUMP_WAV))) {
    fprintf (stderr, "Could not load %s!\n", JUMP_WAV);
    MikMod_Exit ();
    exit (2);
  }
  if (!(pick = Sample_Load (PICK_WAV))) {
    fprintf (stderr, "Could not load %s!\n", PICK_WAV);
    MikMod_Exit ();
    exit (2);
  }
  if (!(die = Sample_Load (DIE_WAV))) {
    fprintf (stderr, "Could not load %s!\n", DIE_WAV);
    MikMod_Exit ();
    exit (2);
  }
  MikMod_SetNumVoices (-1, 15);
  MikMod_EnableOutput ();
}
